#ifndef AGBOXSHM_H
#define AGBOXSHM_H

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define SHM_PORT 8522
#define SHM_PATH "/"


typedef struct{
    int device_type;
    char product_code[50];
    char attribute_name[60];
    char attribute_code[20];
    unsigned int Enabled;
} ProductAttribute;

typedef struct{
    int device_type;
    char device_code[50];
    char device_id[50];
    char product_code[50];
    char device_gateway[50];
    unsigned int lastTime;
    unsigned int Enabled;
}Device;

typedef struct {
    uint t_time;
}ProcessStatus;

typedef struct {
    unsigned char Enabled;
    Device device[1024];
    ProcessStatus processStatus[128];
    ProductAttribute procuctattrbute[300];
}AGBoxShm;


#endif // AGBOXSHM_H
