#ifndef HIK_HTTPUTIL_H
#define HIK_HTTPUTIL_H

#if (defined(WIN32) || defined(WIN64))
	#ifdef HTTPUTIL_EXPORTS
		#define HTTPUTIL_API extern "C" _declspec(dllexport)
	#else
		#define HTTPUTIL_API extern "C" _declspec(dllimport)
	#endif
#else  // LINUX
	#define HTTPUTIL_API extern "C"
#endif

namespace httpUtil
{
	// ״̬붨: 
	// 0 ʾɹ
	// 10000~20000 ʾĴ. 
	// С100000 ʾHTTP״̬루404HTTP״̬вHTTP״̬붨
	const int  HTTPUTIL_ERR_SUCCESS = 0;                                   // ɹ
	const int  HTTPUTIL_ERR_BASE = 10000;                                  // ׼
	const int  HTTPUTIL_ERR_PARAM = (HTTPUTIL_ERR_BASE + 1);               // 紫ָ롢ʱʱ䲻
	const int  HTTPUTIL_ERR_ALLOC_SESSION = (HTTPUTIL_ERR_BASE + 2);       // HTTPsessionʧ
	const int  HTTPUTIL_ERR_SET_HEADER_FIELD = (HTTPUTIL_ERR_BASE + 3);    // ͷʧ
	const int  HTTPUTIL_ERR_SEND_REQUEST = (HTTPUTIL_ERR_BASE + 4);        // HTTPʧ
	const int  HTTPUTIL_ERR_ALLOC_MEM = (HTTPUTIL_ERR_BASE + 5);           // ڴ
	const int  HTTPUTIL_ERR_GET_REDIRECT_URL = (HTTPUTIL_ERR_BASE + 6);    // ȡضUrlʧ
	const int  HTTPUTIL_ERR_OTHER = (HTTPUTIL_ERR_BASE + 10000);           // 

	// HTTP POST
	// url: url
	// body: body
	// appkey: APIṩAPPKey
	// secret: APIṩAPPSecret
	// timeout: 뼶ʱʱ䣨ڲֱʹô˳ʱʱýӡ͡ȴظʱʱ䣩
	// dataLen: ӦݳȣȷصַָNULL
	// return: HTTPӦǶƣdataLenȡݡʧܷNULLʹHTTPUTIL_GetLastStatusȡ״̬롣ɹʹHTTPUTIL_Freeͷڴ
	HTTPUTIL_API char* HTTPUTIL_Post(const char* url, const char* body, const char* appkey, const char* secret, int timeout, int* dataLen);

	// HTTP GET
	// url: url
	// appkey: APIṩAPPKey
	// secret: APIṩAPPSecret
	// timeout: 뼶ʱʱ䣨ڲֱʹô˳ʱʱýӡ͡ȴظʱʱ䣩
	// dataLen: ӦݳȣȷصַָNULL
	// return: HTTPӦǶƣdataLenȡݡʧܷNULLʹHTTPUTIL_GetLastStatusȡ״̬롣ɹʹHTTPUTIL_Freeͷڴ
	HTTPUTIL_API char* HTTPUTIL_Get(const char* url, const char* appkey, const char* secret, int timeout, int* dataLen);

	// ͷڴ
	// buffer: pHTTPUTIL_GetHTTPUTIL_Postصķǿָ
	HTTPUTIL_API void HTTPUTIL_Free(char* buffer);

	// ȡ״̬룬ڵHTTPUTIL_PostHTTPUTIL_Get߳е˽ӿ
	// return: ״̬, HTTPUTIL_ERR_*вHTTP״̬
	HTTPUTIL_API int HTTPUTIL_GetLastStatus();
}
#endif